/*
 * C
 *
 * Copyright 2015-2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include "LLNET_Cfg.h"

#include "fsl_rnga.h"

// RNG initialization state
static uint8_t LLNET_RNG_initialized = 0;

/**
 * Returns a 32 bit random number.
 */
uint32_t LLNET_getRandomNumber(){
  uint32_t randomVal;
  if(!LLNET_RNG_initialized){
    /* Init RNGA */
    RNGA_Init(RNG);
    LLNET_RNG_initialized = 1;
  }
  
  if (kStatus_Success != RNGA_GetRandomData(RNG, &randomVal, sizeof(randomVal)))
  {
    // An error occured
    while(1);
  }

  return randomVal;

}
