/*
 * Copyright 2014-2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "LLBSP_impl.h"
#include "microej.h"
#include <stdio.h>

/* Defines -------------------------------------------------------------------*/

/**
 * Memory settings on TWR-K65F180M
 */
#define SDRAM_START (0x08000000)
#define SDRAM_END (0x0FFFFFFF)
#define SRAM_START (0x1C000000)
#define SRAM_END (0x20100000)
#define EXT_SDRAM_START (0x70000000)
#define EXT_SDRAM_END (0x90000000)

/* Public functions ----------------------------------------------------------*/

// Checks if the given pointer is in a read only memory or not.
uint8_t LLBSP_IMPL_isInReadOnlyMemory(void* ptr) {
	if ((((uint32_t) ptr) >= SDRAM_START && ((uint32_t) ptr) < SDRAM_END)
			|| (((uint32_t) ptr) >= SRAM_START && ((uint32_t) ptr) < SRAM_END)
			|| (((uint32_t) ptr) >= EXT_SDRAM_START
					&& ((uint32_t) ptr) < EXT_SDRAM_END))
		return MICROEJ_FALSE;
	else
		return MICROEJ_TRUE;
}

/**
 * Writes the character <code>c</code>, cast to an unsigned char, to stdout stream.
 * This function is used by the default implementation of the Java <code>System.out</code>.
 */
void LLBSP_IMPL_putchar(int32_t c)
{
	putchar(c);
}
