/*
 * C
 *
 * Copyright 2013-2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "device.h"
#include "LLDEVICE_impl.h"
#include <stdio.h>
#include <string.h>

#include "fsl_sim.h"

#include <sni.h>

uint8_t LLDEVICE_IMPL_getArchitecture(uint8_t* buffer, int32_t length) {
	if (length >= 5) {
		buffer[0]= 'M';
		buffer[1]= 'K';
		buffer[2]= '6';
		buffer[3]= '5';
		buffer[4]= 0;
		return 1;
	} 
	else {
		return 0;
	}
}

uint32_t LLDEVICE_IMPL_getId(uint8_t* buffer, int32_t length) {
	uint8_t bufferOffset = 0;
	if(length < UNIQUE_DEVICE_ID_SIZE){
		return 0;
	}
	sim_uid_t deviceUID;
	SIM_GetUniqueId(&deviceUID);
#if defined(SIM_UIDH)
	memcpy(buffer, &deviceUID.H, sizeof(deviceUID.H));
	bufferOffset += sizeof(deviceUID.H);
#endif
	memcpy(buffer + bufferOffset, &deviceUID.MH, sizeof(deviceUID.MH));
	bufferOffset += sizeof(deviceUID.MH);
	memcpy(buffer + bufferOffset, &deviceUID.ML, sizeof(deviceUID.ML));
	bufferOffset += sizeof(deviceUID.ML);
	memcpy(buffer + bufferOffset, &deviceUID.L, sizeof(deviceUID.L));
	bufferOffset += sizeof(deviceUID.L);

	return UNIQUE_DEVICE_ID_SIZE;
}
